/*======================================================*/
/*														*/
/*	straightFileEx.h									*/
/*						(c) HAL 2009-					*/
/*		straightFileEx class is the I/O class			*/
/*								of a ".stf" file.		*/
/*														*/
/*======================================================*/
#ifndef __straightFileEx_h__
#define __straightFileEx_h__

#include "vConnectObjectBase.h"
#include "straightFrameEx.h"
#include "waveFileEx.h"

class straightFileEx : public vConnectObjectBase{
public:
	straightFileEx();
	~straightFileEx();

	VCNT_RESULT	readStfFile( string fileName );
	VCNT_RESULT	writeStfFile( string fileName );
	VCNT_RESULT	straightCompute( waveFileEx& wave );
	VCNT_RESULT	straightSynthesis( waveFileEx& wave );

	VCNT_RESULT setFrame( long frameIndex, straightFrameEx& frame );
	VCNT_RESULT	getFrame( long frameIndex, straightFrameEx& frame );

	VCNT_RESULT	setNumFrames( long srcNumFrames );
	VCNT_RESULT	setF0( long frameIndex, double srcF0 );
	VCNT_RESULT	setAperiodicity( long frameIndex, vector<double>& aperiodicityBuffer );
	VCNT_RESULT	setAperiodicity( long frameIndex, double* aperiodicityBuffer, long bufferLength );
	VCNT_RESULT	setSpectrum( long frameIndex, vector<double>& spectrumBuffer );
	VCNT_RESULT	setSpectrum( long frameIndex, double* spectrumBuffer, long bufferLength );

	long		getNumFrames( void ){ return numFrames; }
	double		getF0( long frameIndex );
	VCNT_RESULT	getAperiodicity( long frameIndex, vector<double>& aperiodicityBuffer );
	VCNT_RESULT	getAperiodicity( long frameIndex, double* aperiodicityBuffer, long bufferLength );
	VCNT_RESULT	getSpectrum( long frameIndex, vector<double>& spectrumBuffer );
	VCNT_RESULT	getSpectrum( long frameIndex, double* spectrumBuffer, long bufferLength );
	long		getAperiodicityNumFrequencyLength( void ){ return aperiodicityNumFrequencyLength; }
	long		getSpecgramNumFrequencyLength( void ){ return spectrumNumFrequencyLength; }

protected:
private:
	void		setParameters();

	double				f0;
	StraightSource		source;
	StraightSpecgram	specgram;

	long	numFrames;
	long	aperiodicityNumFrequencyLength;
	long	spectrumNumFrequencyLength;
};

#endif
