/*======================================================*/
/*														*/
/*	utauVoiceDataBase.h									*/
/*						(c) HAL 2009-					*/
/*		utauVoiceDataBase class contains				*/
/*			the default data of UTAU settings.			*/
/*														*/
/*======================================================*/
#ifndef __utauVoiceDataBase_h__
#define __utauVoiceDataBase_h__

#include "vConnectObjectBase.h"
#include "utauParameters.h"
#include "straightFileEx.h"
#include "waveFileEx.h"

class utauVoiceDataBase : public vConnectObjectBase {
public:
	utauVoiceDataBase(){}
	~utauVoiceDataBase();

	VCNT_RESULT	readUtauVoiceDataBase( string fileName );
	VCNT_RESULT getUtauParameters( utauParameters& parameters, string search );
	VCNT_RESULT	getVoicePath( string& dst ){ dst = voicePath; return VCNT_TRUE; }
	VCNT_RESULT straightAnalysis( void );
protected:
private:
	string	voicePath;
	MAP_TYPE< string, utauParameters* >	settingMap;
	list< utauParameters* >	settingList;
};

#endif
