/*======================================================*/
/*														*/
/*	vConnectObjectBase.h								*/
/*						(c) HAL 2009-					*/
/*		 vConnectObjectBase is a base class 			*/
/*					of all vConnect objects.			*/
/*======================================================*/
#ifndef __vConnectObjectBase_h__
#define __vConnectObjectBase_h__

#include <stdio.h>
#include <math.h>
#if __GNUC__
#include <sys/stat.h>
#else
#include <direct.h>
#endif

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <list>

using namespace std;

#ifdef __GNUC__
#include <map>
using namespace std;
#define MAP_TYPE map
#else
#include <hash_map>
using namespace stdext;
#define MAP_TYPE hash_map
#endif

char *c_getline( char *buf, int length, FILE *fp );
int c_mkdir( const char *path );
#define LINEBUFF_LEN 4096
#ifdef __GNUC__
const string PATH_SEPARATOR = "/";
#else
const string PATH_SEPARATOR = "\\";
#endif

#include <straight/straight.h>

//#define DEBUG
#define ST_PI 3.141592653589793238462643383279

enum VCNT_RESULT{
	VCNT_FALSE	=	-1,
	VCNT_TRUE	=	0,
	VCNT_FILE_NOT_FOUND,
	VCNT_OUT_OF_MEMORY,
	VCNT_INVALID_CALL,
	VCNT_UNKNOWN
};

#define __STRAIGHT_TANDEM__

class vConnectObjectBase{
public:
	virtual	~vConnectObjectBase(){}

	static	void	outputError( const char* message );
	static	void	writeErrorLog( const char* fileName );
protected:
	static	Straight		straight;
	static	StraightConfig	config;
private:
	static	string	errorString;
};

#endif
