#ifndef __vsqConverter_h__
#define __vsqConverter_h__

#include "vConnectConverterBase.h"
#include "vsqFileEx.h"

#define NOTE_NUM 128
#define VIB_NUM 128
#define VEL_NUM 128
#define AVR_PREU 15

class vsqConverter : public vConnectConverterBase {
public:
	vsqConverter();

	VCNT_RESULT	getData( string inputFileName, vConnectData &dstData );
private:
	void		setControl( vConnectFrame& frame, vsqControl& control );
	void		calculatePronounce( vConnectPronounce& pronounce, vsqEventEx& note, long noteBeginFrame, long noteEndFrame, char velocity, float fixedLength, unsigned long frameIndex );
	double		getPitchFluctuation( double second );
	vsqFileEx	vsq;
	double		noteFrequency[NOTE_NUM];
	double		noteExtention[VEL_NUM];
	double		vibrato[VIB_NUM];
};

#endif