/*======================================================*/
/*														*/
/*	vsqEventEx.h										*/
/*						(c) HAL 2009-					*/
/*	 This class is an extention of vsqEvent.			*/
/*	,contains the information of a note.				*/
/*														*/
/*======================================================*/
#ifndef __vsqEventEx_h__
#define __vsqEventEx_h__

#include "vsqBase.h"
#include "vsqHandle.h"
#include "vsqPhonemeDB.h"
#include "vsqTempo.h"
#include "utauParameters.h"

class vsqEventEx : public vsqBase {
public:

	vsqEventEx(){
		utauSetting.fileName = "";
		utauSetting.lyric = "";
		utauSetting.msLeftBlank = 0.0f;
		utauSetting.msFixedLength = 0.0f;
		utauSetting.msRightBlank = 0.0f;
		utauSetting.msPreUtterance = 0.0f;
		utauSetting.msVoiceOverlap = 0.0f;
		vibratoDelay = 0;
	}
	void	setParameter( string left, string right );
	void	setTick( long tick ){ this->tick = tick; }
	void	setVoiceDataBase( vsqPhonemeDB& voiceDataBase );
	long	getActualTick(){ return actualTick; }
	long	getEndTick( void ){ return ( tick + length ); }
	long	getTick( void ){ return tick; }
	long	getLength( void ){ return length; }
	string	getLyric( void ){ return lyricHandle.getLyric(); }
	char	getVelocity( void ){ return velocity; }
	unsigned char getNote( void ){ return note; }
	float	getRightBlank( void ){ return utauSetting.msRightBlank; }
	float	getLeftBlnak( void ){ return utauSetting.msLeftBlank; }
	float	getFixedLength( void ){ return utauSetting.msFixedLength; }
	double	getPortamentoLength( void ){ return portamentoLength / 100.0; }
	double	getPortamentoDepth( void ){ return portamentoDepth / 100.0; }
	int		getVibratoRate( long tick );
	double	getVibratoDepth( long tick );
	string	getType( void ){ return type; }

	string	getStfFileName( void ){ return ( utauSetting.fileName + ".stf" ); }

	void	applyPreUtterance( void );
protected:
private:
	vsqHandle	vibratoHandle;
	vsqHandle	lyricHandle;

	string			type;
	long			tick;
	long			actualTick;
	long			length;
	long			vibratoDelay;
	unsigned char	note;
	char			velocity;
	unsigned char	portamentoDepth;
	unsigned char	portamentoLength;
	unsigned char	portamentoUse;
	unsigned char	decay;
	unsigned char	attack;

	long			beginFrame;
	long			endFrame;

	utauParameters	utauSetting;
};

#endif