/*======================================================*/
/*														*/
/*	vsqEventList.cpp									*/
/*						(c) HAL 2009-					*/
/*														*/
/*======================================================*/
#include "vsqEventList.h"

vsqEventList::~vsqEventList()
{
	for( unsigned long i = 0; i < eventList.size(); i++ )
		if( eventList[i] )
			delete eventList[i];
}

void vsqEventList::setParameter( string left, string right )
{
    /* If Back is EOS, Front is End Tick */
    if( right.compare( "EOS" ) == 0 )
        endTick = atol( left.c_str() );
    else{
        vsqEventEx* target = new vsqEventEx;
        right = "[" + right + "]";
		target->setTick( atol( left.c_str() ) );
        eventList.push_back( target );
		objectMap.insert( make_pair( right, (vsqBase*)target ) );
    }
}

long vsqEventList::getBeginTick( void )
{
	long result = -1;
	for( unsigned long i = 0; i < eventList.size(); i++ ){
		if( eventList[i] ){
			if( eventList[i]->getType().compare( "Anote" ) == 0 ){
				result = eventList[i]->getActualTick();
				break;
			}
		}
	}
	return result;	
}

void vsqEventList::applyPreUtterance( void )
{
	for( unsigned long i = 0; i < eventList.size(); i++ )
		if( eventList[i] )
			eventList[i]->applyPreUtterance();
}

void vsqEventList::setVoiceDataBase( vsqPhonemeDB& voiceDB )
{
	for( unsigned long i = 0; i < eventList.size(); i++ )
		if( eventList[i] )
			eventList[i]->setVoiceDataBase( voiceDB );
}

void vsqEventList::getEvents( long tick, vsqEventProperty& notes )
{
	unsigned long i;
	notes.present = notes.next = NULL;

	if( tick > 12000 )
		int a = 0;
	for( i = 0; i < eventList.size(); i++ ){
		if( eventList[i] && eventList[i]->getType().compare( "Anote" ) == 0 && eventList[i]->getActualTick() <= tick && tick < eventList[i]->getEndTick() ){
			unsigned long k;
			/* get present note. */
//			if( i!= 0 )
//				i--;
			for( k = i+1; k < eventList.size(); k++ ){
				if( eventList[k] && eventList[k]->getType().compare( "Anote" ) != 0 )
					continue;
				/* get next note. */
//				if( eventList[k]->getActualTick() > tick )
//					if( k != 0 )
//						k--;
				notes.next = eventList[k];
				break;
				
			}
			break;
		}
	}
	if( i == eventList.size() )
		i--;

	if( eventList[i] && eventList[i]->getType().compare( "Anote" ) == 0 && eventList[i]->getActualTick() <= tick && tick < eventList[i]->getEndTick() ){
		notes.present = eventList[i];
		if( notes.present ){
			notes.presentActualTick = notes.present->getActualTick();
			notes.presentEndTick = notes.present->getEndTick();
			notes.presentNote = notes.present->getNote();
			notes.presentTick = notes.present->getTick();
			notes.presentLength = notes.present->getLength();
			notes.presentPortamentoLength = notes.present->getPortamentoLength();
			notes.presentPortamentoDepth = notes.present->getPortamentoDepth();
			notes.presentFixedLength = notes.present->getFixedLength();
			notes.presentVelocity = notes.present->getVelocity();
			if( notes.next ){
				notes.nextActualTick = notes.next->getActualTick();
				notes.nextEndTick = notes.next->getEndTick();
				notes.nextNote = notes.next->getNote();
				notes.nextVelocity = notes.next->getVelocity();
				notes.nextFixedLength = notes.next->getFixedLength();
			}
		}
	}
}
