/*======================================================*/
/*														*/
/*	vsqBPList.h											*/
/*						(c) HAL 2009-					*/
/*														*/
/*======================================================*/
#include "vsqHandle.h"

void vsqLyric::setLyric( string right )
{
	lyric = right.substr( 0, right.find( "," ) );
	lyric = lyric.substr( lyric.find( "\"" ) + 1, lyric.rfind( "\"" ) - 1 );
	right = right.substr( right.find( "," ) + 1 );
	pronounce = right.substr( 0, right.find( "," ) );
	pronounce = pronounce.substr( pronounce.find( "\"" ) + 1, pronounce.rfind( "\"" ) - 1 );

	right = right.substr( right.find( "," ) + 1 );
	lyricDelta = atoi( right.substr( 0, right.find( "," ) ).c_str() );

	right = right.substr( right.find( "," ) + 1 );
	consonantAdjustment = atoi( right.substr( 0, right.find( "," ) ).c_str() );

	right = right.substr( right.find( "," ) + 1 );
	protectFlag = atoi( right.substr( 0, right.find( "," ) ).c_str() );

}

void vsqHandle::setParameter( string left, string right )
{
    if( left.compare( "IconID" ) == 0 )
        iconID = right;
    else if( left.compare( "IDS" ) == 0)
        IDS = right;
    else if( left.compare( "Caption" ) == 0 )
        caption = right;
    else if( left.compare( "Length" ) == 0 )
        length = atoi( right.c_str() );
    else if( left.compare( "Language" ) == 0 )
        language = atoi( right.c_str() );
    else if( left.compare( "Program" ) == 0 )
        program = atoi( right.c_str() );
    else if( left.compare( "Original" ) == 0 )
        original = atoi( right.c_str() );
    else if( left.compare( "StartDepth" ) == 0 ){
        vsqVibratoBP point;
        point.value = atoi( right.c_str() );
		point.position = 0.0;
        vibratoDepth.push_back( point );
    }else if( left.compare( "DepthBPNum" ) == 0 ){
        unsigned int new_size = atoi( right.c_str() ) + 1;
        vibratoDepth.resize( new_size );
    }else if( left.compare( "DepthBPX" ) == 0 ){
        for( unsigned long n=1; n < vibratoDepth.size(); n++ ){
            vibratoDepth[n].position = (float)atof( right.substr( 0, right.find( "," ) ).c_str() );
            right = right.substr( right.find( "," ) );
        }
    }else if( left.compare( "DepthBPY" ) == 0 ){
        for( unsigned long n=1; n < vibratoDepth.size(); n++ ){
            vibratoDepth[n].value = atoi( right.substr( 0, right.find( "," ) ).c_str() );
            right = right.substr( right.find( "," ) + 1);
        }
    }else if( left.compare( "StartRate" ) == 0 ){
        vsqVibratoBP point;
        point.value = atoi( right.c_str() );
        point.position = 0.0;
        vibratoRate.push_back( point );
    }else if( left.compare( "RateBPNum" ) == 0 ){
        unsigned int new_size = atoi( right.c_str() ) + 1;
        vibratoRate.resize( new_size );
    }else if( left.compare( "RateBPX" ) == 0 ){
        for( unsigned long n=1; n < vibratoRate.size(); n++ ){
            vibratoRate[n].position = (float)atof( right.substr( 0, right.find( "," ) ).c_str() );
            right = right.substr( right.find( "," ) );
        }
    }else if( left.compare( "RateBPY" ) == 0 ){
        for( unsigned long n=1; n < vibratoRate.size(); n++ ){
			vibratoRate[n].value = atoi( right.substr( 0, right.find( "," ) ).c_str() );
            right = right.substr( right.find( "," ) + 1 );
        }
    }else if( left.find( "L" ) != string::npos )
        lyric.setLyric( right );
	else{
		string Message = "warning: unknown Property in VsqHandle : " + left;
		outputError( Message.c_str() );
	}
}

short vsqHandle::getVibratoDepth( double position )
{
	short ret;
	unsigned long i;
	for( i = 0; i < vibratoDepth.size(); i++ )
		if( vibratoDepth[i].position > position )
			break;
	if( i != 0 ){
		i--;
		ret = vibratoDepth[i].value;
	} else
		ret = 0;

	return ret;
}

short vsqHandle::getVibratoRate( double position )
{
	short ret = 0;
	unsigned long i;
	for( i = 0; i < vibratoRate.size(); i++ )
		if( vibratoRate[i].position > position )
			break;
	if( i != 0 ){
		i--;
		ret = vibratoRate[i].value;
	} else
		ret = 0;

	return ret;
}
