/*======================================================*/
/*														*/
/*	waveFileEx.h										*/
/*						(c) HAL 2009-					*/
/*		 waveFileEx class is the I/O class 				*/
/*				of Linear 16bits mono-PCM File.			*/
/*		This file contains 64 bits buffer fow wave.		*/
/*														*/
/*======================================================*/
#ifndef __waveFileEx_h__
#define __waveFileEx_h__

#include "vConnectObjectBase.h"

struct waveFormatEx {
	short				chunkID;
	long				chunkSize;
	short				formatTag;
	unsigned	short	numChannels;
	unsigned	long	samplePerSecond;
	unsigned	long	bytesPerSecond;
	unsigned	short	blockAlign;
	unsigned	short	bitsPerSample;
};

class waveFileEx : public vConnectObjectBase {
public:
	waveFileEx();
	/* If the data is stereo, only left-channel will be read. */
	VCNT_RESULT	readWaveFile( string fileName );
	VCNT_RESULT	writeWaveFile( string fileName );

	VCNT_RESULT	setWaveBuffer( vector<double>& srcBuffer );
	VCNT_RESULT	setWaveBuffer( double* srcBuffer, unsigned long bufferLength );

	VCNT_RESULT	getWaveBuffer( vector<double>& dstBuffer );
	VCNT_RESULT	getWaveBuffer( double* dstBuffer, unsigned long* bufferLength );

	VCNT_RESULT getWaveBuffer( vector<double>& dstBuffer, double leftBlank, double rightBlank );

	long		getWaveLength( void ){ return waveBuffer.size(); }

	VCNT_RESULT	setOffset( double secOffset );
	void		normalize( void );
	void		applyDynamics( vector<double>& dynamics );

protected:
private:
	bool		readWaveHeader( FILE* fp );
	bool		readWaveData( FILE* fp );

	void		setDefaultFormat( void );

	vector<double>	waveBuffer;
	waveFormatEx	format;
};

#endif
